// StreamDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Stream.h"
#include "StreamDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char setPath[256]={0};
bool bYes=false;

typedef enum _FILE_INFORMATION_CLASS {
	FileDirectoryInformation = 1,
	FileFullDirectoryInformation,
	FileBothDirectoryInformation,
	FileBasicInformation,
	FileStandardInformation,
	FileInternalInformation,
	FileEaInformation,
	FileAccessInformation,
	FileNameInformation,
	FileRenameInformation,
	FileLinkInformation,
	FileNamesInformation,
	FileDispositionInformation,
	FilePositionInformation,
	FileFullEaInformation,
	FileModeInformation,
	FileAlignmentInformation,
	FileAllInformation,
	FileAllocationInformation,
	FileEndOfFileInformation,
	FileAlternateNameInformation,
	FileStreamInformation,
	FilePipeInformation,
	FilePipeLocalInformation,
	FilePipeRemoteInformation,
	FileMailslotQueryInformation,
	FileMailslotSetInformation,
	FileCompressionInformation,
	FileCopyOnWriteInformation,
	FileCompletionInformation,
	FileMoveClusterInformation,
	FileOleClassIdInformation,
	FileOleStateBitsInformation,
	FileNetworkOpenInformation,
	FileObjectIdInformation,
	FileOleAllInformation,
	FileOleDirectoryInformation,
	FileContentIndexInformation,
	FileInheritContentIndexInformation,
	FileOleInformation,
	FileMaximumInformation
} FILE_INFORMATION_CLASS, *PFILE_INFORMATION_CLASS;

struct FILE_STREAM_INFORMATION
{
	ULONG NextEntryOffset;
	ULONG StreamNameLength;
	LARGE_INTEGER StreamSize;
	LARGE_INTEGER StreamAllocationSize;
	WCHAR StreamName[1];
};

//
// Define the base asynchronous I/O argument types
//

typedef struct _IO_STATUS_BLOCK {
	NTSTATUS Status;
	ULONG Information;
} IO_STATUS_BLOCK, *PIO_STATUS_BLOCK;


DWORD __stdcall NtQueryInformationFile(
	IN HANDLE FileHandle,
	OUT PIO_STATUS_BLOCK IoStatusBlock,
	OUT PVOID FileInformation,
	IN ULONG Length,
	IN FILE_INFORMATION_CLASS FileInformationClass
	);

typedef DWORD (__stdcall *NQIF)(
	IN HANDLE FileHandle,
	OUT PIO_STATUS_BLOCK IoStatusBlock,
	OUT PVOID FileInformation,
	IN ULONG Length,
	IN FILE_INFORMATION_CLASS FileInformationClass
	);

NQIF nqif = NULL;
const int MAXLEN = 2048; // arbitrary filename length limit

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStreamDlg dialog

CStreamDlg::CStreamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStreamDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStreamDlg)
	m_path = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CStreamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStreamDlg)
	DDX_Control(pDX, IDC_LIST, m_memo);
	DDX_Control(pDX, IDC_EDIT1, m_pathlist);
	DDX_Text(pDX, IDC_EDIT1, m_path);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CStreamDlg, CDialog)
	//{{AFX_MSG_MAP(CStreamDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDABOUT, OnAbout)
	ON_BN_CLICKED(IDBROWSE, OnBrowse)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStreamDlg message handlers

BOOL CStreamDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	/*
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	*/
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CStreamDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CStreamDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CStreamDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CStreamDlg::OnAbout() 
{
	// TODO: Add your control notification handler code here
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CStreamDlg::OnBrowse() 
{
	// TODO: Add your control notification handler code here
	char pszDisplayName[256];
	BROWSEINFO BrowseInfo;
	LPITEMIDLIST pidlBrowse;
	LPMALLOC pMalloc;
	if( !SUCCEEDED(SHGetMalloc(&pMalloc)) )
		return ;
	BrowseInfo.hwndOwner = m_hWnd;
	BrowseInfo.pidlRoot = NULL;
	BrowseInfo.pszDisplayName = pszDisplayName;
	BrowseInfo.lpszTitle = "ָһĿ¼:";
	BrowseInfo.ulFlags = BIF_DONTGOBELOWDOMAIN;
	BrowseInfo.lpfn = NULL;
	BrowseInfo.lParam = 0;
	BrowseInfo.iImage = 0;
	pidlBrowse = SHBrowseForFolder(&BrowseInfo);
	if( pidlBrowse!=NULL )
	{
		if( SHGetPathFromIDList(pidlBrowse,pszDisplayName) )
		{
			strcpy(setPath,pszDisplayName);
			m_pathlist.SetWindowText((LPCTSTR)pszDisplayName);
			//((CButton *)GetDlgItem(IDC_LOCAL_BROWS))->EnableWindow(false);
			bYes=true;
		}
		pMalloc->Free(pidlBrowse);
	}
	pMalloc->Release();
}


void CStreamDlg::OnOK() 
{
	// TODO: Add extra validation here
	CWnd::UpdateData(TRUE);
	
	if(m_path.IsEmpty()||!bYes)
	{
		AfxMessageBox("û·,޷ļĲ.");
		return;
	}

	int numFilesWithStreams, numStreams;
	wchar_t path[MAXLEN] = L"";
	wchar_t tmpPath[MAXLEN]=L"";
	wchar_t tmpPath1[MAXLEN]=L"";
	wchar_t *p, *endOfPath;
	WIN32_FIND_DATA wfd;
	HANDLE ffh;
	HINSTANCE hNtdll;
	char errmsg[256]={0};

	hNtdll = LoadLibrary("ntdll.dll");
	if ( hNtdll < (HINSTANCE) 33 )
	{
	
		AfxMessageBox("Error loading NTDLL.DLL. Huh?\n");
		return;
	}

	nqif = (NQIF) GetProcAddress( hNtdll, "NtQueryInformationFile" );
	if ( nqif == NULL )
	{
		AfxMessageBox("NQIF() missing from NTDLL.DLL. Huh?\n");
		FreeLibrary( hNtdll );
		return;
	}

	if(bYes)
	{
		wcscpy(path, (const unsigned short *)setPath );
	}
	else
	{
		_tcscpy((char *)path,m_path);		
	}

	for ( p = path; *p != L'\0'; ++ p )
	{
		if ( *p == L'/' )
			*p = L'\\';
	}

	p = wcsrchr( path, L'\\' ); // isolate last backslash
	if ( p == NULL ) // no backslash, only a filespec
		endOfPath = path;
	else
	{
		endOfPath = p + 1;
		if ( *endOfPath == L'\0' ) // no filespec?
			wcscpy( endOfPath, L"*" ); // invent one
	}

	// loop over files
	wcscpy(tmpPath, path );
	sprintf((char *)path,"%s\\*.*",(const char *)path);
	ffh = FindFirstFile((const char *) path, &wfd );
	if ( ffh != INVALID_HANDLE_VALUE )
	{
		BOOL ok=true;
		do
		{
			if ( ( wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) != 0 )
			{
				// it's a directory -- may want to recurse
			}
			else // it's a file
			{
				wcscpy( endOfPath,(const unsigned short *) wfd.cFileName ); // tack file onto path
				sprintf((char *)tmpPath1,"%s\\%s",tmpPath,path);
				checkOneFile( tmpPath1, numFilesWithStreams, numStreams);
			}
			ok = FindNextFile( ffh, &wfd );
		} while ( ok );
		FindClose( ffh );
	}
	else
	{
		sprintf(errmsg,"Error %d when searching for \"%s\".\n", GetLastError(), path );
		AfxMessageBox(errmsg);
	}
	m_memo.AddString("Scan complete .");
	return;
}



void CStreamDlg::checkOneFile( const wchar_t *file, int& numFilesWithStreams, int& numStreams )
{
	HANDLE h;
	DWORD rc;
	IO_STATUS_BLOCK iosb;
	static byte fsibuf[32768];
	FILE_STREAM_INFORMATION *fsi;
	bool mustPrintName = true;
	wchar_t abc[100]=L"";
	char ab[100]={0};
	char abd[100]={0};
	static const wchar_t * const DefaultStreamName = L"::$DATA";
	static const ULONG DefaultStreamNameLength = 7;
	int bc;
	char errmsg[100]={0};
	CString memo;

	// note that while we do have to open the file, not even read access is needed
	h = CreateFile((const char *)file, 0, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
		OPEN_EXISTING, 0, NULL );
	if ( h == INVALID_HANDLE_VALUE )
	{
		sprintf(errmsg,"Error %d opening \"%s\".\n", GetLastError(), file );
		AfxMessageBox(errmsg);
		return;
	}

	rc = nqif( h, &iosb, &fsibuf, sizeof( fsibuf ), FileStreamInformation );
	if ( rc != 0 )
	{
		sprintf(errmsg,"Error %d [NTSTATUS %ld/%08lxh] on NQIF() of \"%s\".\n",
			LsaNtStatusToWinError( rc ), rc, rc, file );
		AfxMessageBox(errmsg);
		CloseHandle( h );
		return;
	}
	
	CloseHandle( h );

	fsi = (FILE_STREAM_INFORMATION *) fsibuf;

	while ( 1 )
	{
		if ( fsi->StreamNameLength != 2 * DefaultStreamNameLength ||
			wcsncmp( fsi->StreamName, DefaultStreamName, DefaultStreamNameLength ) != 0 )
		{
			// non-default stream found!
			if ( mustPrintName )
			{
				// first stream for this file, bump file count and show file name
				++ numFilesWithStreams;
				//m_memo.AddString(file);
				//wprintf( L"\n%s\n", file );
				mustPrintName = false;
			}
			// bump stream count, show stream info
			++ numStreams;
			swprintf(abc,L"%2I64u %-*.*s\n",fsi->StreamSize, fsi->StreamNameLength / 2,fsi->StreamNameLength,fsi->StreamName);
			for(bc=0;bc<=100;bc++)wctomb(&ab[bc],abc[bc]);
			bc=':';
			sprintf(abd,"%s",strchr(ab,bc));
			
			memo.Format("Find Stream File: %s%s",file,abd);
			m_memo.AddString(memo);
		}
		if ( fsi->NextEntryOffset == 0 )
			break;
		fsi = (FILE_STREAM_INFORMATION *) ( fsi->NextEntryOffset + (byte *) fsi );
	}

	return;
}

void CStreamDlg::OnChangeEdit1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	bYes=false;	
}

